@echo off
rem back up/restore CD-i NVRAM
rem
rem rosewood@retrostuff.org
rem 2023-03-07
rem
rem for use with CD-i Link 0.5.2 (compatibility with other versions untested)
rem download from https://www.cdiemu.org/cdilink/
rem
rem options:
rem %1 operation: backup (default), restore.
if [%1]==[] (set operation=backup) else (set operation=%1)
rem %2 COM port number: default 1.
if [%2]==[] (set port=1) else (set port=%2)
rem set "stub=" && rem option for Philips CD-i players
set "stub= -n" && rem option for non-Philips CD-i players
rem

call :%operation%
echo:
if %errorlevel% equ 0 echo All done!
if %errorlevel% equ 1 echo CD-i Link returned an error!
if %errorlevel% equ 2 echo Backup directory doesn't exist!
if %errorlevel% equ 3 echo Backup file list doesn't exist!
pause >nul
goto :eof

:backup
	rem full backup of all files in /nvr
	cdilink.exe -p %port% -k%stub%
	if %errorlevel% equ 1 (exit /b)
	cdilink.exe -p %port% -c -dir /nvr > cdinvr.txt
	if %errorlevel% equ 1 (exit /b)
	if not exist backup md backup
	pushd backup
	for /f "skip=5 tokens=2*" %%a in (..\cdinvr.txt) do (..\cdilink.exe -p %port% -c -uc "/nvr/%%a%%b")
	popd
	cdilink.exe -p %port% -c -e
	goto :eof

:restore
	rem full restore of all files, as initially listed in cdinvr.txt
	cdilink.exe -p %port% -k%stub%
	if %errorlevel% equ 1 (exit /b)
	if not exist backup (exit /b 2)
	if not exist cdinvr.txt (exit /b 3)
	pushd backup
	for /f "skip=5 tokens=2*" %%a in (..\cdinvr.txt) do (..\cdilink.exe -p %port% -c -dc "/nvr/%%a%%b")
	popd
	cdilink.exe -p %port% -c -e
	goto :eof